"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var core_1 = require('@angular/core');
var Modal = (function () {
    function Modal() {
        this.modalClass = '';
        this.emitSubmit = new core_1.EventEmitter();
        this.isOpened = false;
    }
    Modal.prototype.ngOnInit = function () {
        this.createBackDrop();
        this.combinedModalClass = this.modalClass ? 'modal-dialog ' + this.modalClass : 'modal-dialog';
    };
    Modal.prototype.open = function () {
        var _this = this;
        this.isOpened = true;
        document.body.appendChild(this.backdropElement);
        setTimeout(function () { return _this.modal.nativeElement.focus(); }, 0);
    };
    Modal.prototype.close = function () {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i - 0] = arguments[_i];
        }
        this.isOpened = false;
        if (this.backdropElement.parentElement) {
            document.body.removeChild(this.backdropElement);
            this.emitSubmit.emit(args[0]);
        }
    };
    Modal.prototype.createBackDrop = function () {
        this.backdropElement = document.createElement('div');
        this.backdropElement.classList.add('fade', 'in', 'modal-backdrop');
    };
    __decorate([
        core_1.Input(), 
        __metadata('design:type', String)
    ], Modal.prototype, "modalClass", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', String)
    ], Modal.prototype, "title", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', String)
    ], Modal.prototype, "submitLabel", void 0);
    __decorate([
        core_1.Output(), 
        __metadata('design:type', Object)
    ], Modal.prototype, "emitSubmit", void 0);
    __decorate([
        core_1.ViewChild('modal'), 
        __metadata('design:type', core_1.ElementRef)
    ], Modal.prototype, "modal", void 0);
    Modal = __decorate([
        core_1.Component({
            selector: 'modal',
            styles: [require('!!css-loader!less-loader!./modal.less').toString()],
            template: require('./modal.html')
        }), 
        __metadata('design:paramtypes', [])
    ], Modal);
    return Modal;
}());
exports.Modal = Modal;
//# sourceMappingURL=modal.js.map